-- NPC talk system


function sf94.msg(p, text, style)
	if style ~= 100 and p.msg and p.msgStyle == 100 then return end

	-- Regular NPC
	if style == 0 then
		if not p.msg then
			p.msgLine = 0
			p.msgAlpha = 10
		elseif p.msgStyle == 1 then
			return
		end
		p.msgTime = 1

	-- Special NPC
	elseif style == 1 then
		p.msgLine = 0
		p.msgAlpha = 10
		p.msgTime = 7 * TICRATE

	-- Sign
	elseif style == 2 then
		if not p.msg then
			p.msgLine = 32
			p.msgAlpha = 10
		elseif p.msgStyle == 1 then
			return
		end
		p.msgTime = 1
	end

	p.msg = text
	p.msgStyle = style
end

function sf94.infoMsg(p, msg)
	if not (p.msg and p.msgStyle == 100) then
		p.msgAlpha = 10
	end
	p.msgLine = 32
	p.msgTime = 4 * TICRATE
	p.msg = msg
	p.msgStyle = 100
end


addHook("LinedefExecute", function(l, mo)
	local messageId = l.frontside.textureoffset / FU
	local style = l.frontside.rowoffset / FU

	local text = sf94.messages[G_BuildMapName(gamemap)][messageId]
	if type(text) == "table" then
		if sf94.event and text[sf94.event.id] then
			text = text[sf94.event.id]
		else
			text = text.normal
		end

		if type(text) == "function" then
			text = text()
		end
	end

	if style == 1 or not (mo.player and mo.player.valid) then
		for p in players.iterate do
			sf94.msg(p, text, style)
		end
	else
		sf94.msg(mo.player, text, style)
	end
end, "NPCTALK")

addHook("ThinkFrame", do
	for p in players.iterate do
		if not p.msg then continue end

		if p.msgTime == 0 then
			if p.msgAlpha == 9 then
				p.msg = nil
				continue
			end
			if (leveltime & 3) == 3 then
				p.msgAlpha = $ + 1
			end
		else
			if p.msgAlpha ~= 0 then
				p.msgAlpha = $ - 1
			end
			p.msgTime = $ - 1
		end
		if leveltime % 2 == 1 and p.msgLine < 32 then
			p.msgLine = $ + 1
		end
	end
end)

addHook("MapLoad", do
	for p in players.iterate do
		p.msg = nil
	end
end)


local function msg_bottom(v, text, alpha, n)
	local x, y = 160, 160

	for line in text:gmatch("[^\n]+") do
		y = $ - 12
	end
	for line in text:gmatch("[^\n]+") do
		if n == 0 then return end
		n = $ - 1
		v.drawString(x, y, line, V_ALLOWLOWERCASE | (alpha << V_ALPHASHIFT), "center")
		y = $ + 12
	end
end

local function msg_center(v, text, alpha, n)
	local x, y = 160, 100

	for line in text:gmatch("[^\n]+") do
		y = $ - 6
	end
	for line in text:gmatch("[^\n]+") do
		if n == 0 then return end
		n = $ - 1
		v.drawString(x, y, line, V_ALLOWLOWERCASE | (alpha << V_ALPHASHIFT), "center")
		y = $ + 12
	end
end

hud.add(function(v, p)
	if not p.msg then return end

	if p.msgStyle ~= 100 then
		msg_bottom(v, p.msg, p.msgAlpha, p.msgLine)
	else
		msg_center(v, p.msg, p.msgAlpha, p.msgLine)
	end
end, "game")
