freeslot(
	"MT_SF94_OLDNPC",

	"MT_SF94_OLDSTANDNPC",
	"MT_SF94_OLDSTANDNPC_SKIN1",
	"MT_SF94_OLDSTANDNPC_SKIN2",
	"MT_SF94_OLDSTANDNPC_SKIN3",
	"MT_SF94_OLDSTANDNPC_SKIN4"
)


local function chooseNpcColor(mo)
	repeat
		mo.color = P_RandomRange(1, #skincolors - 1)
	until mo.color ~= skins[mo.skin].prefcolor
end


-- Fix for A_ChangeAngleRelative and A_ChangeAngleAbsolute
-- (P_RandomRange only handles ranges < 65536)
function A_SF94_ChangeAngleRelative(mo, var1, var2)
	mo.angle = $ + FixedAngle(P_RandomRange(var1, var2) * FU)
end

function A_SF94_ChangeAngleAbsolute(mo, var1, var2)
	mo.angle = FixedAngle(P_RandomRange(var1, var2) * FU)
end

function A_SF94_NPC_Decide(mo)
	if P_RandomChance(FU/2) then
		mo.angle = $ + FixedAngle(P_RandomRange(-90, 90) * FU)
	end

	if P_RandomChance(FU/4) then
		mo.state = S_SF94_OLDNPC_WAIT

		mo.tics = P_RandomRange(TICRATE, 3*TICRATE)
		if P_RandomChance(FU/4) then
			mo.tics = $ * 4
		end
	else
		mo.state = S_SF94_OLDNPC_WALK
	end
end


addHook("MobjSpawn", function(mo)
	mo.skin = skins[P_RandomKey(#skins)].name
	chooseNpcColor(mo)
end, MT_SF94_OLDNPC)

addHook("MobjSpawn", function(mo)
	mo.skin = skins[P_RandomKey(#skins)].name
	chooseNpcColor(mo)
end, MT_SF94_OLDSTANDNPC)

addHook("MobjSpawn", function(mo)
	mo.skin = "sonic"
	chooseNpcColor(mo)
end, MT_SF94_OLDSTANDNPC_SKIN1)

addHook("MobjSpawn", function(mo)
	mo.skin = "tails"
	chooseNpcColor(mo)
end, MT_SF94_OLDSTANDNPC_SKIN2)

addHook("MobjSpawn", function(mo)
	mo.skin = "tails"
	chooseNpcColor(mo)
end, MT_SF94_OLDSTANDNPC_SKIN3)

addHook("MobjSpawn", function(mo)
	mo.skin = "amy"
	chooseNpcColor(mo)
end, MT_SF94_OLDSTANDNPC_SKIN4)


local cv_allowresetnpcs = CV_RegisterVar({"allowresetnpcs", "Off", CV_NETVAR, CV_OnOff})

COM_AddCommand("resetnpcs", function(p)
	if not cv_allowresetnpcs.value and not (p == server or p == admin) then
		CONS_Printf(p, "Sorry, allowresetnpcs is off so only the server or an administrator can use this.")
		return
	end

	-- Remove all moving NPCs
	local npcstoremove = {}
	for mo in mobjs.iterate() do
		if mo.type == MT_SF94_OLDNPC then
			npcstoremove[#npcstoremove + 1] = mo
		end
	end
	for i = 1, #npcstoremove do
		P_RemoveMobj(npcstoremove[i])
	end

	-- Respawn NPCs
	local typetocheck = mobjinfo[MT_SF94_OLDNPC].doomednum
	for sp in mapthings.iterate do
		if sp.type == typetocheck then
			local x = sp.x * FU
			local y = sp.y * FU
			local z = R_PointInSubsector(x, y).sector.floorheight + sp.z * FU
			local mo = P_SpawnMobj(x, y, z, MT_SF94_OLDNPC)
			mo.angle = FixedAngle(sp.angle * FU)
		end
	end

	/*for mo in mobjs.iterate() do
		if typestocheck[mo.type] then
			local sp = mo.spawnpoint
			if sp then
				local x = sp.x * FU
				local y = sp.y * FU
				local z = R_PointInSubsector(x, y).sector.floorheight + sp.z * FU
				P_SetOrigin(mo, x, y, z)
				mo.angle = FixedAngle(sp.angle * FU)
			end
		end
	end*/
end)
