freeslot("MT_SF94_GIFT", "MT_SF94_TRIGGER")


function sf94.openGift(mo, p)
	if mo.state == S_SF94_GIFT_RED_RIBBON then
		mo.state = S_SF94_GIFT_RED_RIBBON_OPEN
	else
		mo.state = S_SF94_GIFT_GOLD_RIBBON_OPEN
	end
	mo.momx, mo.momy = 0, 0
	mo.flags = $ & ~MF_SOLID & ~MF_PUSHABLE

	local mt = P_RandomKey(256)
	if mt < 32 then
		mt = MT_SF94_GIFT
	elseif mt < 48 then
		mt = MT_SF94_SONICSTATUE
	elseif mt < 56 then
		mt = MT_SF94_PUMPKIN
	elseif mt < 64 then
		mt = MT_SF94_HALLOWEEN_PUMPKIN
	else
		if mo.scale >= FU*2/3 then
			mt = sf94.randomElement{
				MT_RING_BOX       , MT_PITY_BOX      , MT_ATTRACT_BOX   ,
				MT_FORCE_BOX      , MT_ARMAGEDDON_BOX, MT_WHIRLWIND_BOX ,
				MT_ELEMENTAL_BOX  , MT_SNEAKERS_BOX  , MT_INVULN_BOX    , 
				MT_1UP_BOX        , MT_EGGMAN_BOX    , MT_SCORE1K_BOX   ,
				MT_SCORE10K_BOX   , MT_FLAMEAURA_BOX , MT_BUBBLEWRAP_BOX,
				MT_THUNDERCOIN_BOX, MT_SF94_GREYBALL , MT_SF94_BLUEBALL ,
				MT_SF94_REDBALL
			}
		else
			mt = sf94.randomElement{ MT_RING, MT_SF94_CHAO, MT_SF94_EMPANADA }
		end
	end

	local gift = P_SpawnMobj(mo.x, mo.y, mo.z, mt)

	if mt == MT_SF94_GIFT then
		gift.scale = max(mo.scale * 3/4, FU/4)
	elseif mt == MT_SF94_SONICSTATUE then
		gift.scale = mo.scale / 2
	elseif mt == MT_SF94_PUMPKIN or mt == MT_SF94_HALLOWEEN_PUMPKIN then
		gift.scale = mo.scale
	end

	P_RemoveMobj(mo)
end

function sf94.spawnGifts()
	local map = G_BuildMapName(gamemap)
	for _, pos in ipairs(sf94.giftLocations[map] or {}) do
		P_SpawnMobj(pos[1] * FU, pos[2] * FU, pos[3] * FU, MT_SF94_GIFT)
	end
end


addHook("TouchSpecial", function(mo, pmo)
	local p = pmo.player
	if not (p and p.valid and pmo.z == mo.z) then
		return true
	end

	sf94.setAction(p, { type = "gift", gift = mo.target })

	sf94.msg(p, "\x82SPIN\x80: open gift.", 2)
	p.msgAlpha = 8

	return true
end, MT_SF94_TRIGGER)

addHook("MobjThinker", function(mo)
	P_SetOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
end, MT_SF94_TRIGGER)

addHook("MobjRemoved", function(mo)
	if mo.target and mo.target.valid then
		mo.target.trigger = nil
	end
end, MT_SF94_TRIGGER)

addHook("MobjSpawn", function(mo)
	mo.state = S_SF94_GIFT_RED_RIBBON + P_RandomKey(2)
	mo.color = P_RandomRange(1, #skincolors - 1)
	mo.scale = P_RandomRange(FU/2, FU) -- !!!

	mo.trigger = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SF94_TRIGGER)
	mo.trigger.target = mo
	mo.trigger.radius = mo.radius + 32*FU
end, MT_SF94_GIFT)

addHook("MobjRemoved", function(mo)
	if mo.trigger and mo.trigger.valid then
		P_RemoveMobj(mo.trigger)
	end
end, MT_SF94_GIFT)

sf94.addAction{
	id = "gift",
	action = function(p, action)
		if action.gift.valid then
			sf94.openGift(action.gift, p)
		end
	end
}
