-- Jump Sphere by wolfs


local cv_jumpsphere = CV_RegisterVar({"jumpsphere", "On", CV_NETVAR, CV_OnOff})

freeslot("MT_SF94_JUMPSPHERE", "S_SF94_JUMPSPHERE")

mobjinfo[MT_SF94_JUMPSPHERE] = {
	spawnstate = S_SF94_JUMPSPHERE,
	spawnhealth = 1,
	radius = 32*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 0,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY
}
states[S_SF94_JUMPSPHERE] = {SPR_THOK, FF_TRANS50, 0, nil, 0, 0, S_NULL}

addHook("MobjThinker", function(mo)
	local p = mo.player
	if not (p and p.valid) then return end

	if p.pflags & PF_JUMPED and not (p.pflags & PF_GLIDING)
	and cv_jumpsphere.value then
		if not p.jumpsphere
		and (p.mo.skin == "sonic" or p.mo.skin == "tails"
		or p.mo.skin == "knuckles" or p.mo.skin == "metalsonic") then
			p.jumpsphere = P_SpawnMobjFromMobj(mo, 0, 0, -FixedMul(mo.info.height / 4, mo.scale), MT_SF94_JUMPSPHERE)
			p.jumpsphere.target = mo
			p.jumpsphere.scale = mo.scale
			p.jumpsphere.color = mo.color
		end
	elseif p.jumpsphere and p.jumpsphere.valid then
		P_RemoveMobj(p.jumpsphere)
	end

	if p.jumpsphere and not p.jumpsphere.valid then
		p.jumpsphere = nil
	end
end, MT_PLAYER)

addHook("MobjThinker", function(sphere)
	local mo = sphere.target
	if not (mo and mo.valid) then
		P_RemoveMobj(sphere)
		return
	end

	sphere.scale = mo.scale
	sphere.color = mo.color

	local offset
	if P_MobjFlip(mo) == -1 then
		sphere.flags2 = $ | MF2_OBJECTFLIP
		offset = mo.info.height - sphere.height - mo.info.height / 8
	else
		sphere.flags2 = $ & ~MF2_OBJECTFLIP
		offset = -mo.info.height / 8
	end
	P_MoveOrigin(sphere, mo.x, mo.y, mo.z + FixedMul(offset, mo.scale))
end, MT_SF94_JUMPSPHERE)
