freeslot(
	"MT_SF94_GHOSTPUYO",
	"MT_SF94_GHOSTPUYO_DEATH",
	"S_SF94_PUYO_DEATH",
	"S_SF94_GHOSTPUYO",
	"S_SF94_GHOSTPUYO2",
	"S_SF94_GHOSTPUYO3",
	"S_SF94_GHOSTPUYO4",
	"S_SF94_GHOSTPUYO5",
	"S_SF94_GHOSTPUYO6",
	"S_SF94_GHOSTPUYO7",
	"S_SF94_GHOSTPUYO8",
	"S_SF94_GHOSTPUYO9",
	"S_SF94_GHOSTPUYO10",
	"S_SF94_GHOSTPUYO11",
	"S_SF94_GHOSTPUYO12",
	"S_SF94_GHOSTPUYO_DEATH",
	"S_SF94_GHOSTPUYO_DEATH2",
	"S_SF94_PUYOSPAWNER",
	"S_SF94_PUYOSPAWNER2",
	"S_SF94_PUYOSPAWNER3",
	"S_SF94_PUYOSPAWNER4",
	"SPR_PUYO",
	"sfx_puyo1",
	"sfx_puyo2",
	"sfx_puyo3",
	"sfx_puyo4"
)


local function freeslotPrefix(prefix, suffixes)
	for _, suffix in ipairs(suffixes) do
		freeslot(prefix .. suffix)
	end
end


for i, color in ipairs{ "RED", "GREEN", "BLUE", "YELLOW" } do
	local mPrefix = ("MT_SF94_%sPUYO"):format(color)
	local sPrefix = ( "S_SF94_%sPUYO"):format(color)


	local function m(suffix)
		return _G[mPrefix .. suffix]
	end

	local function s(suffix)
		return _G[sPrefix .. suffix]
	end

	local function f(n)
		return 3 * (i - 1) + n
	end


	freeslotPrefix(mPrefix, {
		"",
		"_DEATH",
		"_BLOOD",
	})
	freeslotPrefix(sPrefix, {
		"",
		"_DEATH", "_DEATH2",
		"_DEATH3", "_DEATH4", "_DEATH5",
		"_BLOOD", "_BLOOD2", "_BLOOD3", "_BLOOD4", "_BLOOD5",
	})


	mobjinfo[m""] = {
		doomednum = 4057 + i - 1,
		spawnstate = s"",
		spawnhealth = 3,
		reactiontime = 2,
		painstate = s"",
		deathstate = s"_DEATH",
		speed = 21*FRACUNIT,
		radius = 16*FRACUNIT,
		height = 24*FRACUNIT,
		damage = 1,
		activesound = sfx_puyo2,
		flags = MF_SOLID|MF_SHOOTABLE|MF_PUSHABLE|MF_SLIDEME|MF_BOUNCE
	}

	states[s""] = { SPR_PUYO, TR_TRANS20|f(A), -1 }

	states[s"_DEATH" ] = { SPR_PUYO, TR_TRANS20|f(B), TICRATE/2, nil, 0, 0, s"_DEATH2" }
	states[s"_DEATH2"] = { SPR_NULL, f(A), 0, A_SpawnObjectRelative, 0, m"_DEATH", S_SF94_PUYO_DEATH }


	mobjinfo[m"_DEATH"] = {
		doomednum = -1,
		spawnstate = s"_DEATH3",
		spawnhealth = 1000,
		reactiontime = 8,
		speed = 8,
		radius = 32*FRACUNIT,
		height = 64*FRACUNIT,
		flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY
	}

	states[s"_DEATH3"] = { SPR_NULL, f(A), 1, nil, 0, 0, s"_DEATH4" }
	states[s"_DEATH4"] = { SPR_NULL, f(A), 0, A_OldRingExplode, m"_BLOOD", 0, s"_DEATH5" }
	states[s"_DEATH5"] = { SPR_NULL, f(A), TICRATE, A_PlaySound, sfx_puyo1, 1 }


	mobjinfo[m"_BLOOD"] = {
		doomednum = -1,
		spawnstate = s"_BLOOD",
		spawnhealth = 1000,
		reactiontime = 8,
		speed = 8,
		radius = 32*FRACUNIT,
		height = 64*FRACUNIT,
		flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY
	}

	states[s"_BLOOD" ] = { SPR_PUYO, f(C), TICRATE/2, nil, 0, 0, s"_BLOOD2" }
	states[s"_BLOOD2"] = { SPR_PUYO, f(C), 0, A_DualAction, s"_BLOOD4", s"_BLOOD5", s"_BLOOD3" }
	states[s"_BLOOD3"] = { SPR_PUYO, f(C), TICRATE/2, A_Thrust, 24, 0 }
	states[s"_BLOOD4"] = { SPR_NULL, f(A), 0, A_FindTarget, m"_DEATH", 0 }
	states[s"_BLOOD5"] = { SPR_NULL, f(A), 0, A_FaceTarget, 0, 0 }
end
