-- Rolling snowballs!


freeslot("MT_SF94_ROLLING_SNOWBALL")


-- They see me rollin'
addHook("MobjSpawn", function(mo)
	mo.scale = FU/8
	mo.destscale, mo.scalespeed = FU/2, FU/128
end, MT_SF94_ROLLING_SNOWBALL)

-- They hatin'
addHook("MobjThinker", function(mo)
	mo.friction = FU*255/256
	if mo.destscale < 8*FU and mo.subsector.sector.floorpic == "SNOW01" and P_IsObjectOnGround(mo) then
		mo.destscale = $ + P_AproxDistance(mo.momx, mo.momy) / 8192
	end
end, MT_SF94_ROLLING_SNOWBALL)

-- Patrollin' and tryna catch me ridin' dirty
addHook("TouchSpecial", function(mo, pmo)
	local oldDist = R_PointToDist2(pmo.x, pmo.y, mo.x, mo.y)
	local newDist = R_PointToDist2(pmo.x + pmo.momx, pmo.y + pmo.momy, mo.x + mo.momx, mo.y + mo.momy)
	if newDist < oldDist then
		mo.momx, mo.momy = pmo.momx, pmo.momy
	end

	return true
end, MT_SF94_ROLLING_SNOWBALL)

-- Tryna catch me ridin' dirty
addHook("MobjCollide", function(mo1, mo2)
	if mo2.type == MT_SF94_ROLLING_SNOWBALL
	and max(mo1.scale, mo2.scale) >= FU
	and mo1.z <= mo2.z + mo2.height and mo1.z + mo1.height >= mo2.z then
		local snowman
		if mo1.scale > mo2.scale then
			snowman = P_SpawnMobj(mo1.x, mo1.y, mo1.z, MT_SNOWMAN)
			snowman.scale = 36 * mo1.scale / 45
		else
			snowman = P_SpawnMobj(mo2.x, mo2.y, mo2.z, MT_SNOWMAN)
			snowman.scale = 36 * mo2.scale / 45
		end

		snowman.flags = $ & ~MF_PUSHABLE

		P_RemoveMobj(mo1)
		P_RemoveMobj(mo2)
	elseif mo2.type == MT_SF94_OLDNPC
	and mo1.scale > mo2.scale
	and P_AproxDistance(mo1.momx, mo1.momy) > 8*FU then
		P_DamageMobj(mo2)
		mo2.momx, mo2.momy = mo1.momx, mo1.momy
	end
end, MT_SF94_ROLLING_SNOWBALL)
