sf94.cv_ringregrab = CV_RegisterVar{
	name = "ringregrab",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	possibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			print("Ring Regrab enabled. Red rings and rail rings no longer disappear after colliding.")
		else
			print("Ring Regrab disabled. Red rings and rail rings now disappear after colliding.")
		end
	end
}

sf94.cv_sandboxmode = CV_RegisterVar{
	name = "sandboxmode",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	possibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			print("Sandbox Mode enabled. Red rings now spawn balls and grenade rings will spawn springs, allowing you to build things. Other weapons are not affected, so you can still shoot the balls to make them jump when necessary.")
		else
			print("Sandbox Mode disabled. Red rings no longer spawn balls.")
		end
	end
}

sf94.cv_puyomode = CV_RegisterVar{
	name = "puyomode",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	possibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			print("Puyo mode enabled. Red rings now spawn Puyos. When a Puyo is popped, a Giant Nuisance Puyo will shoot a small Nuisance Puyo at you.")
		else
			print("Puyo mode disabled. Red rings no longer spawn Puyos.")
		end
	end
}

sf94.cv_flamethrower = CV_RegisterVar{
	name = "flamethrower",
	defaultvalue = "Off",
	flags = CV_NETVAR|CV_CALL|CV_NOINIT,
	possibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			print("Flamethrower enabled. Automatic rings are now replaced with flames.")
		else
			print("Flamethrower disabled.")
		end
	end
}


function A_SF94_RedRingDeath(mo)
	if sf94.cv_puyomode.value then
		local mt = sf94.randomElement{
			MT_SF94_REDPUYO , MT_SF94_GREENPUYO,
			MT_SF94_BLUEPUYO, MT_SF94_YELLOWPUYO
		}
		P_SpawnMobjFromMobj(mo, 0, 0, 0, mt)
	elseif sf94.cv_ringregrab.value then
		P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_RING)
	elseif sf94.cv_sandboxmode.value then
		P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SF94_BALL)
	end
end

function A_SF94_AutomaticDeath(mo)
	if sf94.cv_flamethrower.value then
		P_RemoveMobj(mo)
	end
end

function A_SF94_GrenadeDeath(mo)
	if sf94.cv_sandboxmode.value then
		P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_YELLOWSPRING)
	end
end


freeslot("S_SF94_REDRING_DEATH", "S_SF94_AUTOMATIC_DEATH", "S_SF94_GRENADE_DEATH")

mobjinfo[MT_REDRING].deathstate = S_SF94_REDRING_DEATH
mobjinfo[MT_THROWNAUTOMATIC].deathstate = S_SF94_AUTOMATIC_DEATH
mobjinfo[MT_THROWNGRENADE].deathstate = S_SF94_GRENADE_DEATH

states[S_SF94_REDRING_DEATH] = {
	tics = 0,
	action = A_SF94_RedRingDeath,
	nextstate = S_SPRK1
}

states[S_SF94_AUTOMATIC_DEATH] = {
	tics = 0,
	action = A_SF94_AutomaticDeath,
	nextstate = S_SPRK1
}

states[S_SF94_GRENADE_DEATH] = {
	tics = 0,
	action = A_SF94_GrenadeDeath,
	nextstate = S_SPRK1
}


addHook("MobjSpawn", function(mo)
	if sf94.cv_puyomode.value then
		mo.state = S_SF94_PUYOSPAWNER
	end
end, MT_REDRING)

addHook("MobjSpawn", function(mo)
	if sf94.cv_flamethrower.value then
		mo.state = S_FLAMEJETFLAME1
		mo.flags = $ | MF_FIRE
		S_StartSound(mo, sfx_fire)
	end
end, MT_THROWNAUTOMATIC)
