sf94.interactions = {}


if not P_SetOrigin then
	rawset(_G, "P_SetOrigin", P_TeleportMove)
	rawset(_G, "P_MoveOrigin", P_TeleportMove)
end


local joined = false
local welcomed = false


-- For the Empanada Hut key sparkles
function A_RandomSparkles(mo, var1)
	P_SpawnMobj(
		mo.x + P_RandomRange(-8, 8) * FU,
		mo.y + P_RandomRange(-8, 8) * FU,
		mo.z + P_RandomRange(0, 32) * FU,
		var1
	)
end

local function welcome(p)
	if not p then
		for p in players.iterate do
			welcome(p)
		end
		return
	end

	CONS_Printf(p, "")
	CONS_Printf(p, " ###### .#######   #####  * . ####  .  .   ######. #######  ###### . ##*  ##")
	CONS_Printf(p, "##. *    ## *. *  ## * ##    ##.##        ##  .    ## .  *  ## .*##  ##   ##")
	CONS_Printf(p, " ##### * ##### .   ######.  ##* ##. #### * ##### * #####  . ######.  ## .*##")
	CONS_Printf(p, ". *  ##. ##. *     *   ##  #######  * .   .    ##  ## * .   ##* .## * ## ##")
	CONS_Printf(p, "######   ##  .  * ######    *   ## .      ######  *####### *##   ##  . ###")
	CONS_Printf(p, "")
	CONS_Printf(p, "Version " .. sf94.VERSION .. ", MKIII")
	CONS_Printf(p, "Type \"sf94help\" in the console if you need information about this add-on.")
end


COM_AddCommand("sf94welcome", function(p)
	welcome(p)
end, 0)

COM_AddCommand("sf94version", function(p)
	CONS_Printf(p, "Version " .. sf94.VERSION .. ", MKIII")
end)

local function help(p)
	CONS_Printf(p, "\x83\nVariables\x80")
	CONS_Printf(p, "blood flamethrower puyomode ringregrab sandbox")
	CONS_Printf(p, "\x83\nCommands\x80")
	CONS_Printf(p, "event resetnpcs sf94version sf94welcome timehelp")
end

COM_AddCommand("sf94help", help)
COM_AddCommand("helpsf94", help)

COM_AddCommand("commands", function(p)
	CONS_Printf(p, "This command has been renamed as \"sf94help\".")
end)

COM_AddCommand("orderempanada", function(p, on)
	COM_BufInsertText(p, "say /me has ordered a delicious empanada.")
end, 0)

-- By LJ Sonic, who was lazy to manually update every linedef with Award Score action set =p
addHook("LinedefExecute", function(line, mo)
	if mo.player and mo.player.valid then
		P_AddPlayerScore(mo.player, line.frontsector.floorheight / FRACUNIT)
	end
end, "AWARDSCOREOLD")

-- Poisonous liquid that makes you lavender (the most important feature)
addHook("LinedefExecute", function(line, mo)
	mo.color = SKINCOLOR_LAVENDER
end, "LAVENDER")

addHook("LinedefExecute", function(line, mo)
	local mission = line.frontside.textureoffset / FRACUNIT
	local map = G_BuildMapName(gamemap)

	if map == "MAPZ1" then
		if mission == 1 then
			if sf94.interactions.empanadaHut and sf94.interactions.empanadaHut.valid then
				P_RemoveMobj(sf94.interactions.empanadaHut)
			end
		elseif mission == 2 then
			if sf94.interactions.ball and sf94.interactions.ball.valid then
				P_RemoveMobj(sf94.interactions.ball)
			end
		end
	end
end, "MISSIONSUCCESS")

addHook("LinedefExecute", function()
	G_ExitLevel(nil, 1)
end, "EXITMAP")

addHook("PlayerSpawn", function(p)
	if not p.mo then return end

	P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SF94_SPAWN_FOG)
	S_StartSound(p.mo, sfx_pspawn)
end)

addHook("MapLoad", function()
	if welcomed then
		welcome()
		welcomed = true
	end

	--for mo in mobjs.iterate() do
	--	if mo.type == MT_SF94_PUMPKIN then
	--		mo.type, mo.state = MT_SF94_HALLOWEEN_PUMPKIN, S_SF94_HALLOWEEN_PUMPKIN
	--	end
	--end

	local map = G_BuildMapName(gamemap)

	sf94.interactions = {}

	if map == "MAPZ1" then -- SF94 Plaza
		sf94.interactions.empanadaHut = P_SpawnMobj(-320*FU, 1024*FU, 64*FU, MT_SF94_EXCLAMATIONMARK)
		sf94.interactions.ball = P_SpawnMobj(2240*FU, -384*FU, 296*FU, MT_SF94_EXCLAMATIONMARK)
	end

	if sf94.event then
		if sf94.event.id == "christmas" then
			if sf94.noChristmas then
				sf94.stopChristmasEvent()
			else
				sf94.startChristmasEvent()
			end
		elseif sf94.event.id == "halloween" then
			sf94.startHalloweenEvent()
			sf94.event.strokes = 0
		end
	--elseif not sf94.noChristmas then
	--	print("Christmas event activated by default. Type "event stop" if you wish to disable it.")
	--	sf94.startChristmasEvent()
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not p.sf94 then
			p.sf94 = {}
		end
	end

	if joined and consoleplayer then
		joined = false
		sf94.startLocalEventStuff()
	end

	if sf94.event then
		sf94.updateEvent()
	end

	for p in players.iterate do
		p.sf94.oldDashSpeed = p.dashspeed

		if p.sf94.action and leveltime >= p.sf94.action.time + 2 then
			p.sf94.action = nil
		end
	end
end)

addHook("NetVars", function(n)
	if not isserver then
		joined = true
	end

	sf94.interactions = n($)
end)
