-- Real shops! Spin to buy.


function sf94.buy(p)
	local action = p.sf94.action
	local item, price = action.item, action.price

	if p.rings < price then return end

	if item < 100 then -- Shields
		local shields = {
			SH_WHIRLWIND , SH_ATTRACT   , SH_ELEMENTAL  ,
			SH_ARMAGEDDON, SH_BUBBLEWRAP, SH_THUNDERCOIN,
			SH_FLAMEAURA , SH_PITY      ,
			SH_FORCE | 1 , SH_FORCE | 2 , SH_FORCE | 3
		}

		p.powers[pw_shield] = ($ & SH_STACK) | shields[item]
		P_SpawnShieldOrb(p)
	elseif item == 101 then -- Invincibility
		if p.powers[pw_invulnerability] <= 65535 - 20 * TICRATE then
			p.powers[pw_invulnerability] = $ + 20 * TICRATE
		else
			p.powers[pw_invulnerability] = 65535
		end
		S_StopMusic(p)
		S_ChangeMusic("_inv", false, p)
	elseif item == 102 then -- Super Sneakers
		if p.powers[pw_sneakers] <= 65535 - 20 * TICRATE
			p.powers[pw_sneakers] = $ + 20 * TICRATE
		else
			p.powers[pw_sneakers] = 65535
		end
		S_StopMusic(p)
		S_ChangeMusic("_shoes", false, p)
	elseif item == 103 then -- Extra Live
		P_GivePlayerLives(p, 1)
		P_PlayLivesJingle(p)
	elseif item == 104 then -- Eggman's Box
		P_DamageMobj(p.mo, nil, nil, 1)
	elseif item == 105 then -- 10 Rings Box
		P_GivePlayerRings(p, 10)
	elseif item < 300 then -- Scale change
		if item == 201 then
			item = FRACUNIT
		elseif item == 202 then
			item = FRACUNIT / 4
		elseif item == 203 then
			item = 7 * FRACUNIT / 4
		end

		p.mo.destscale = item
	elseif item == 1001 or item == 1002 then -- Santa Hat
		if not sf94.givePlayerSantaHat(p) then return end
	end

	S_StartSound(p.mo, sfx_chchng)

	P_GivePlayerRings(p, -price)
end


addHook("LinedefExecute", function(line, mo)
	if not mo.valid then return end
	local p = mo.player
	if not (p and p.valid) then return end

	local item = line.frontside.textureoffset / FRACUNIT
	local price = line.frontside.rowoffset / FRACUNIT

	p.msgLine = 32
	p.msgStyle = 0
	if not p.msg then
		p.msgAlpha = 10
	end
	p.msgTime = 1
	if item == 104 and price == 0 then -- Eggman's Box for free 8)
		p.msg = "Lol it's free."
	elseif item == 1002 then
		if p.mo.hat
			p.msg = "<Random  NPC>\nMy  brother  works  at  SF94-Hospital.\nDid  I  tell  you?"
		else
			p.msg = "<Random  NPC>\nDo  you  need  some  clothes?\nI  sell  Santa  hats  for  " .. price .. "  Rings!"
		end
	elseif p.rings >= price then
		p.msg = "\x82SPIN\x80: buy for\n" .. price .. " Rings."
	else
		p.msg = "Price: \n" .. price .. " Rings"
	end

	sf94.setAction(p, { type = "shop", item = item, price = price })
end, "SHOP")

sf94.addAction{
	id = "shop",
	action = function(p)
		sf94.buy(p)
	end
}
